<template>
  <div class="records" :class="themeClasses">
    <contact-panel
      v-if="contact"
      :order="order"
      @close="() => closeContactPanel()"
      @success="() => closeContactPanel(true)"
    />

    <contact-success-panel
      v-if="contactSuccess"
      @close="contactSuccess = false"
    />

    <table v-if="!loading">
      <thead>
        <tr>
          <td>{{ $t("preorderRecordList.orderTime") }}</td>
          <td>{{ $t("preorderRecordList.restaurant") }}</td>
          <td>{{ $t("preorderRecordList.pickupTime") }}</td>
          <td>{{ $t("preorderRecordList.number") }}</td>
          <td>{{ $t("preorderRecordList.amount") }}</td>
          <td>{{ $t("preorderRecordList.status") }}</td>
          <td>{{ $t("preorderRecordList.action") }}</td>
          <td></td>
        </tr>
      </thead>
      <tbody>
        <tr v-for="record in records" :key="record.OrderId" class="record">
          <td>
            {{ createdTime(record).format("YYYY/M/D dddd") }}<br />
            {{ createdTime(record).format("HH:mm") }}
          </td>
          <td class="col-name">
            <div class="col-name-wrapper">
              <div class="col-name-logo" :style="logoStyle(record)"></div>
              <div class="col-name-detail">
                <div class="reservation-name">
                  {{ record.RestaurantName }}
                </div>
                <div class="restaurant-address">
                  {{ record.BuildingAddress || "" }}
                </div>
              </div>
            </div>
          </td>
          <td>
            {{ reservationTime(record).format("YYYY/M/D dddd") }}<br />
            {{ reservationTime(record).format("HH:mm") }}
          </td>
          <td>{{ last6Char(record.OrderId) || "" }}</td>
          <td><price :price="totalValue(record)" /></td>
          <td><status :order="record" :nocolor="true" /></td>
          <td>
            <button
              class="action-button cancel"
              @click="() => cancel(record)"
              v-if="cancellable(record)"
            >
              {{ $t("preorderRecordList.cancel") }}
            </button>
            <button
              class="action-button contact"
              @click="openContactPanel(record)"
              v-else
            >
              {{ $t("preorderRecordList.contact") }}
            </button>
          </td>
          <td>
            <router-link
              :to="{
                name: 'PreorderRecord',
                params: { orderId: record.OrderId }
              }"
              >{{ $t("preorderRecordList.view") }}</router-link
            >
          </td>
        </tr>
      </tbody>
    </table>
    <div v-if="!loading && !records.length" class="empty">
      {{ $t("preorderRecordList.noRecords") }}
    </div>
  </div>
</template>

<script>
import moment from "moment";
import Status from "./Status";
import { mapGetters, mapState } from "vuex";
import * as Api from "@/api";
import RecordItem from "./RecordItem";
import Price from "../../components/Price";
import ContactPanel from "@/components/Preorder/ContactPanel";
import ContactSuccessPanel from "@/components/Preorder/ContactSuccessPanel";
import { STATUS_AWAIT } from "@/models/preorder";
import { last6Char } from "@/utils";

export default {
  components: {
    Price,
    Status,
    RecordItem,
    ContactPanel,
    ContactSuccessPanel
  },

  props: {
    loading: {
      type: Boolean,
      default: false
    },
    records: {
      type: Array,
      default: () => []
    },
    type: {
      type: String,
      default: ""
    }
  },

  data() {
    return {
      order: null,
      contact: false,
      contactSuccess: false
    };
  },

  computed: {
    ...mapState("account", ["account"]),
    ...mapGetters("theme", ["themeClasses"])
  },

  methods: {
    last6Char,
    openContactPanel(order) {
      this.order = order;
      this.contact = true;
    },

    closeContactPanel(success) {
      this.order = null;
      this.contact = false;
      if (success) {
        this.contactSuccess = true;
      }
    },

    cancel(record) {
      if (confirm(this.$t("preorderRecords.cancelConfirm"))) {
        Api.Order.deleteOrder(record.OrderId, this.account).then(res => {
          if (res.data.StatusCode === 0) {
            alert(this.$t("preorderRecords.cancelError"));
          } else {
            alert(this.$t("preorderRecords.cancelSuccess"));
            this.$router.push({
              name: "PreorderRecord",
              params: {
                orderId: record.OrderId
              }
            });
          }
        });
      }
    },

    logoStyle(record) {
      return {
        "background-image": `url(${record.RestaurantLogo || ""})`,
        "background-color": record.WebBannerBackgroundColor || ""
      };
    },

    totalValue(record) {
      return record.OrderAmount;
    },

    reservationTime(record) {
      const getTime =
        this.type === "pickUp" ? record.EsPickTime : record.EsDeliveryTime;
      return moment(getTime);
    },

    createdTime(record) {
      return moment(record.OrderTime);
    },

    cancellable(record) {
      return record.OrderCancel;
    }
  }
};
</script>

<style lang="scss" scoped>
.records table {
  font-size: 14px;
  line-height: 1.8em;
  width: 100%;
  border-collapse: collapse;
  border: 1px $color-sky-grey solid;
  white-space: nowrap;

  td {
    border: 1px $color-sky-grey solid;
    padding: 10px;
  }

  thead {
    background: $color-silver-grey;

    td {
      border-color: $color-pigeon-grey;
    }
  }

  .col-name {
    min-width: 272px;
  }

  .col-name-wrapper {
    display: flex;
    align-items: center;
    width: 100%;
  }

  .col-name-logo {
    display: inline-block;
    width: 68px;
    height: 68px;
    background-size: contain;
    background-repeat: no-repeat;
    background-position: center center;
    vertical-align: middle;
    margin-right: 15px;
    border-radius: 4px;
    flex-shrink: 0;
    flex-grow: 0;
    border: 12px transparent solid;
    box-sizing: border-box;
  }

  .col-name-detail {
    display: inline-block;
    flex-grow: 1;

    .reservation-name,
    .reservation-address {
      display: block;
    }

    .reservation-name {
      font-size: 18px;
      margin-top: 0.5em;
      margin-bottom: 0.15em;
    }

    .reservation-address {
      font-size: 13px;
      color: $color-primary-grey;
    }
  }

  .record {
    background: $color-white;

    &.cancelled {
      opacity: 0.5;
    }
  }
}

.records.theme-vip-member table {
  thead {
    background: $color-skm-gold2;
    color: $color-white;

    td {
      border-color: #aa925c;
    }
  }

  td {
    border-color: #ddcfaf;
  }

  .detail-link {
    color: $color-gold-300;
  }
}

.no-records {
  height: 120px;
  line-height: 120px;
  border: 1px $color-sky-grey solid;
  color: $color-pigeon-grey;
  font-size: 18px;
  text-align: center;
  background: $color-white;
}

.col-note {
  width: 200px;
}

.action-button {
  position: relative;
  cursor: pointer;
  background: transparent;
  border: none;
  padding: 0;
  line-height: 25px;
  padding-left: 18px;

  &::before {
    content: "";
    position: absolute;
    width: 12px;
    height: 12px;
    top: 50%;
    left: 0;
    background-position: center center;
    background-repeat: no-repeat;
    background-size: 11px 12px;
    margin-top: -6px;
  }

  &.cancel::before {
    background-image: url("/static/images/ic-cancel.png");
  }

  &.contact::before {
    background-image: url("/static/images/ic-envelope.png");
  }
}

.empty {
  height: 120px;
  line-height: 120px;
  border: 1px #e2e6ee solid;
  color: #9da6b9;
  font-size: 18px;
  text-align: center;
  background: #ffffff;
}
</style>
